diff --git a/src/backend/utils/adt/timestamp.c b/src/backend/utils/adt/timestamp.c
index e6a1eed191..effb305e71 100644
--- a/src/backend/utils/adt/timestamp.c
+++ b/src/backend/utils/adt/timestamp.c
@@ -74,6 +74,9 @@ static void AdjustTimestampForTypmod(Timestamp *time, int32 typmod);
 static void AdjustIntervalForTypmod(Interval *interval, int32 typmod);
 static TimestampTz timestamp2timestamptz(Timestamp timestamp);
 static Timestamp timestamptz2timestamp(TimestampTz timestamp);
+static bool in_range_internal(Datum curr, Datum slot, Datum offset, bool preceding, bool end,
+							   PGFunction miIntervalFunc, PGFunction plIntervalFunc,
+							   PGFunction gtComparatorFunc, PGFunction ltComparatorFunc, bool asc);
 
 
 /* common code for timestamptypmodin and timestamptztypmodin */
@@ -5148,6 +5151,90 @@ timestamptz_izone(PG_FUNCTION_ARGS)
 	PG_RETURN_TIMESTAMP(result);
 }
 
+/*----------------------------------------------------------
+ *	In RANGE procedures on timestamps.
+ *---------------------------------------------------------*/
+
+static bool in_range_internal(Datum curr, Datum slot, Datum offset, bool preceding, bool end,
+							   PGFunction miIntervalFunc, PGFunction plIntervalFunc,
+							   PGFunction gtComparatorFunc, PGFunction ltComparatorFunc, bool asc)
+{
+	Datum		result;
+
+	if (preceding)
+		result = DirectFunctionCall2(asc ? miIntervalFunc : plIntervalFunc, curr, offset);
+	else
+		result = DirectFunctionCall2(asc ? plIntervalFunc : miIntervalFunc, curr, offset);
+
+	if (end)
+	{
+		if (DatumGetBool(DirectFunctionCall2(asc ? gtComparatorFunc : ltComparatorFunc, slot, result)))
+			return false;
+	}
+	else
+	{
+		if (DatumGetBool(DirectFunctionCall2(asc ? ltComparatorFunc : gtComparatorFunc, slot, result)))
+			return false;
+	}
+
+	return true;
+}
+
+Datum
+in_range_timestamp_interval_asc(PG_FUNCTION_ARGS)
+{
+	PG_RETURN_BOOL(in_range_internal(PG_GETARG_DATUM(0), PG_GETARG_DATUM(1), PG_GETARG_DATUM(2),
+									 PG_GETARG_BOOL(3), PG_GETARG_BOOL(4),
+									 timestamp_mi_interval, timestamp_pl_interval,
+									 timestamp_gt, timestamp_lt, true));
+}
+
+Datum
+in_range_timestamp_interval_desc(PG_FUNCTION_ARGS)
+{
+	PG_RETURN_BOOL(in_range_internal(PG_GETARG_DATUM(0), PG_GETARG_DATUM(1), PG_GETARG_DATUM(2),
+									 PG_GETARG_BOOL(3), PG_GETARG_BOOL(4),
+									 timestamp_mi_interval, timestamp_pl_interval,
+									 timestamp_gt, timestamp_lt, false));
+}
+
+Datum
+in_range_timestamptz_interval_asc(PG_FUNCTION_ARGS)
+{
+	PG_RETURN_BOOL(in_range_internal(PG_GETARG_DATUM(0), PG_GETARG_DATUM(1), PG_GETARG_DATUM(2),
+									 PG_GETARG_BOOL(3), PG_GETARG_BOOL(4),
+									 timestamptz_mi_interval, timestamptz_pl_interval,
+									 timestamp_gt, timestamp_lt, true));
+}
+
+Datum
+in_range_timestamptz_interval_desc(PG_FUNCTION_ARGS)
+{
+	PG_RETURN_BOOL(in_range_internal(PG_GETARG_DATUM(0), PG_GETARG_DATUM(1), PG_GETARG_DATUM(2),
+									 PG_GETARG_BOOL(3), PG_GETARG_BOOL(4),
+									 timestamptz_mi_interval, timestamptz_pl_interval,
+									 timestamp_gt, timestamp_lt, false));
+}
+
+Datum
+in_range_interval_interval_asc(PG_FUNCTION_ARGS)
+{
+	PG_RETURN_BOOL(in_range_internal(PG_GETARG_DATUM(0), PG_GETARG_DATUM(1), PG_GETARG_DATUM(2),
+									   PG_GETARG_BOOL(3), PG_GETARG_BOOL(4),
+									   interval_mi, interval_pl,
+									   interval_gt, interval_lt, true));
+}
+
+Datum
+in_range_interval_interval_desc(PG_FUNCTION_ARGS)
+{
+	PG_RETURN_BOOL(in_range_internal(PG_GETARG_DATUM(0), PG_GETARG_DATUM(1), PG_GETARG_DATUM(2),
+									   PG_GETARG_BOOL(3), PG_GETARG_BOOL(4),
+									   interval_mi, interval_pl,
+									   interval_gt, interval_lt, false));
+}
+
+
 /* generate_series_timestamp()
  * Generate the set of timestamps from start to finish by step
  */
diff --git a/src/include/catalog/catversion.h b/src/include/catalog/catversion.h
index f1765af4ba..9b98c04124 100644
--- a/src/include/catalog/catversion.h
+++ b/src/include/catalog/catversion.h
@@ -53,6 +53,6 @@
  */
 
 /*							yyyymmddN */
-#define CATALOG_VERSION_NO	201712251
+#define CATALOG_VERSION_NO	201801311
 
 #endif
diff --git a/src/include/catalog/pg_amproc.h b/src/include/catalog/pg_amproc.h
index f545a0580d..751973de03 100644
--- a/src/include/catalog/pg_amproc.h
+++ b/src/include/catalog/pg_amproc.h
@@ -566,5 +566,36 @@ DATA(insert (	4104   603	 603  3  4107 ));
 DATA(insert (	4104   603	 603  4  4108 ));
 DATA(insert (	4104   603	 603  11 4067 ));
 DATA(insert (	4104   603	 603  13  187 ));
+/* in RANGE functions */
+DATA(insert (	5009   20	 20  1 6122 ));
+DATA(insert (	5009   20	 20  2 6123 ));
+DATA(insert (	5009   20	 23  1 6124 ));
+DATA(insert (	5009   20	 23  2 6125 ));
+DATA(insert (	5009   20	 21  1 6126 ));
+DATA(insert (	5009   20	 21  2 6127 ));
+DATA(insert (	5009   23	 20  1 6128 ));
+DATA(insert (	5009   23	 20  2 6129 ));
+DATA(insert (	5009   23	 23  1 6130 ));
+DATA(insert (	5009   23	 23  2 6131 ));
+DATA(insert (	5009   23	 21  1 6132 ));
+DATA(insert (	5009   23	 21  2 6133 ));
+DATA(insert (	5009   21	 20  1 6134 ));
+DATA(insert (	5009   21	 20  2 6135 ));
+DATA(insert (	5009   21	 23  1 6136 ));
+DATA(insert (	5009   21	 23  2 6137 ));
+DATA(insert (	5009   21	 21  1 6138 ));
+DATA(insert (	5009   21	 21  2 6139 ));
+DATA(insert (	5009   1114	 1186  1 6140 ));
+DATA(insert (	5009   1114	 1186  2 6141 ));
+DATA(insert (	5009   1184	 1186  1 6142 ));
+DATA(insert (	5009   1184	 1186  2 6143 ));
+DATA(insert (	5009   1186	 1186  1 6144 ));
+DATA(insert (	5009   1186	 1186  2 6145 ));
+DATA(insert (	5009   1266	 1186  1 6146 ));
+DATA(insert (	5009   1266	 1186  2 6147 ));
+DATA(insert (	5009   1082	 1186  1 6148 ));
+DATA(insert (	5009   1082	 1186  2 6149 ));
+DATA(insert (	5009   1083	 1186  1 6150 ));
+DATA(insert (	5009   1083	 1186  2 6151 ));
 
 #endif							/* PG_AMPROC_H */
diff --git a/src/include/catalog/pg_opfamily.h b/src/include/catalog/pg_opfamily.h
index b544474254..9086fea15f 100644
--- a/src/include/catalog/pg_opfamily.h
+++ b/src/include/catalog/pg_opfamily.h
@@ -187,5 +187,7 @@ DATA(insert OID = 4082 (	3580	pg_lsn_minmax_ops		PGNSP PGUID ));
 DATA(insert OID = 4104 (	3580	box_inclusion_ops		PGNSP PGUID ));
 DATA(insert OID = 5000 (	4000	box_ops		PGNSP PGUID ));
 DATA(insert OID = 5008 (	4000	poly_ops				PGNSP PGUID ));
+DATA(insert OID = 5009 (	403		in_range_ops			PGNSP PGUID ));
+#define IN_RANGE_BTREE_FAM_OID 5009
 
 #endif							/* PG_OPFAMILY_H */
diff --git a/src/include/catalog/pg_proc.h b/src/include/catalog/pg_proc.h
index f01648c961..b2a172b8f1 100644
--- a/src/include/catalog/pg_proc.h
+++ b/src/include/catalog/pg_proc.h
@@ -2701,6 +2701,68 @@ DESCR("aggregate final function");
 DATA(insert OID = 3545 (  string_agg				PGNSP PGUID 12 1 0 0 0 t f f f f f i s 2 0 17 "17 17" _null_ _null_ _null_ _null_ _null_ aggregate_dummy _null_ _null_ _null_ ));
 DESCR("concatenate aggregate input into a bytea");
 
+/* In RANGE functions */
+DATA(insert OID = 6122 (  in_range_int8_int8_asc PGNSP PGUID 12 1 0 0 0 f f f t t f i s 5 0 16 "20 20 20 16 16" _null_ _null_ _null_ _null_ _null_ in_range_int8_int8_asc _null_ _null_ _null_ ));
+DESCR("in range for int8 column, int8 offset, ascending");
+DATA(insert OID = 6123 (  in_range_int8_int8_desc PGNSP PGUID 12 1 0 0 0 f f f t t f i s 5 0 16 "20 20 20 16 16" _null_ _null_ _null_ _null_ _null_ in_range_int8_int8_desc _null_ _null_ _null_ ));
+DESCR("in range for int8 column, int8 offset, descending");
+DATA(insert OID = 6124 (  in_range_int8_int4_asc PGNSP PGUID 12 1 0 0 0 f f f t t f i s 5 0 16 "20 20 23 16 16" _null_ _null_ _null_ _null_ _null_ in_range_int8_int4_asc _null_ _null_ _null_ ));
+DESCR("in range for int8 column, int4 offset, ascending");
+DATA(insert OID = 6125 (  in_range_int8_int4_desc PGNSP PGUID 12 1 0 0 0 f f f t t f i s 5 0 16 "20 20 23 16 16" _null_ _null_ _null_ _null_ _null_ in_range_int8_int4_desc _null_ _null_ _null_ ));
+DESCR("in range for int8 column, int4 offset, descending");
+DATA(insert OID = 6126 (  in_range_int8_int2_asc PGNSP PGUID 12 1 0 0 0 f f f t t f i s 5 0 16 "20 20 21 16 16" _null_ _null_ _null_ _null_ _null_ in_range_int8_int2_asc _null_ _null_ _null_ ));
+DESCR("in range for int8 column, int2 offset, ascending");
+DATA(insert OID = 6127 (  in_range_int8_int2_desc PGNSP PGUID 12 1 0 0 0 f f f t t f i s 5 0 16 "20 20 21 16 16" _null_ _null_ _null_ _null_ _null_ in_range_int8_int2_desc _null_ _null_ _null_ ));
+DESCR("in range for int8 column, int2 offset, descending");
+DATA(insert OID = 6128 (  in_range_int4_int8_asc PGNSP PGUID 12 1 0 0 0 f f f t t f i s 5 0 16 "23 23 20 16 16" _null_ _null_ _null_ _null_ _null_ in_range_int4_int8_asc _null_ _null_ _null_ ));
+DESCR("in range for int4 column, int8 offset, ascending");
+DATA(insert OID = 6129 (  in_range_int4_int8_desc PGNSP PGUID 12 1 0 0 0 f f f t t f i s 5 0 16 "23 23 20 16 16" _null_ _null_ _null_ _null_ _null_ in_range_int4_int8_desc _null_ _null_ _null_ ));
+DESCR("in range for int4 column, int8 offset, descending");
+DATA(insert OID = 6130 (  in_range_int4_int4_asc PGNSP PGUID 12 1 0 0 0 f f f t t f i s 5 0 16 "23 23 23 16 16" _null_ _null_ _null_ _null_ _null_ in_range_int4_int4_asc _null_ _null_ _null_ ));
+DESCR("in range for int4 column, int4 offset, ascending");
+DATA(insert OID = 6131 (  in_range_int4_int4_desc PGNSP PGUID 12 1 0 0 0 f f f t t f i s 5 0 16 "23 23 23 16 16" _null_ _null_ _null_ _null_ _null_ in_range_int4_int4_desc _null_ _null_ _null_ ));
+DESCR("in range for int4 column, int4 offset, descending");
+DATA(insert OID = 6132 (  in_range_int4_int2_asc PGNSP PGUID 12 1 0 0 0 f f f t t f i s 5 0 16 "23 23 21 16 16" _null_ _null_ _null_ _null_ _null_ in_range_int4_int2_asc _null_ _null_ _null_ ));
+DESCR("in range for int4 column, int2 offset, ascending");
+DATA(insert OID = 6133 (  in_range_int4_int2_desc PGNSP PGUID 12 1 0 0 0 f f f t t f i s 5 0 16 "23 23 21 16 16" _null_ _null_ _null_ _null_ _null_ in_range_int4_int2_desc _null_ _null_ _null_ ));
+DESCR("in range for int4 column, int2 offset, descending");
+DATA(insert OID = 6134 (  in_range_int2_int8_asc PGNSP PGUID 12 1 0 0 0 f f f t t f i s 5 0 16 "21 21 20 16 16" _null_ _null_ _null_ _null_ _null_ in_range_int2_int8_asc _null_ _null_ _null_ ));
+DESCR("in range for int2 column, int8 offset, ascending");
+DATA(insert OID = 6135 (  in_range_int2_int8_desc PGNSP PGUID 12 1 0 0 0 f f f t t f i s 5 0 16 "21 21 20 16 16" _null_ _null_ _null_ _null_ _null_ in_range_int2_int8_desc _null_ _null_ _null_ ));
+DESCR("in range for int2 column, int8 offset, descending");
+DATA(insert OID = 6136 (  in_range_int2_int4_asc PGNSP PGUID 12 1 0 0 0 f f f t t f i s 5 0 16 "21 21 23 16 16" _null_ _null_ _null_ _null_ _null_ in_range_int2_int4_asc _null_ _null_ _null_ ));
+DESCR("in range for int2 column, int4 offset, ascending");
+DATA(insert OID = 6137 (  in_range_int2_int4_desc PGNSP PGUID 12 1 0 0 0 f f f t t f i s 5 0 16 "21 21 23 16 16" _null_ _null_ _null_ _null_ _null_ in_range_int2_int4_desc _null_ _null_ _null_ ));
+DESCR("in range for int2 column, int4 offset, descending");
+DATA(insert OID = 6138 (  in_range_int2_int2_asc PGNSP PGUID 12 1 0 0 0 f f f t t f i s 5 0 16 "21 21 21 16 16" _null_ _null_ _null_ _null_ _null_ in_range_int2_int2_asc _null_ _null_ _null_ ));
+DESCR("in range for int2 column, int2 offset, ascending");
+DATA(insert OID = 6139 (  in_range_int2_int2_desc PGNSP PGUID 12 1 0 0 0 f f f t t f i s 5 0 16 "21 21 21 16 16" _null_ _null_ _null_ _null_ _null_ in_range_int2_int2_desc _null_ _null_ _null_ ));
+DESCR("in range for int2 column, int2 offset, descending");
+DATA(insert OID = 6140 (  in_range_timestamp_interval_asc PGNSP PGUID 12 1 0 0 0 f f f t t f i s 5 0 16 "1114 1114 1186 16 16" _null_ _null_ _null_ _null_ _null_ in_range_timestamp_interval_asc _null_ _null_ _null_ ));
+DESCR("in range for timestamp column, interval offset, ascending");
+DATA(insert OID = 6141 (  in_range_timestamp_interval_desc PGNSP PGUID 12 1 0 0 0 f f f t t f i s 5 0 16 "1114 1114 1186 16 16" _null_ _null_ _null_ _null_ _null_ in_range_timestamp_interval_desc _null_ _null_ _null_ ));
+DESCR("in range for timestamp column, interval offset, descending");
+DATA(insert OID = 6142 (  in_range_timestamptz_interval_asc PGNSP PGUID 12 1 0 0 0 f f f t t f i s 5 0 16 "1184 1184 1186 16 16" _null_ _null_ _null_ _null_ _null_ in_range_timestamptz_interval_asc _null_ _null_ _null_ ));
+DESCR("in range for timestamptz column, interval offset, ascending");
+DATA(insert OID = 6143 (  in_range_timestamptz_interval_desc PGNSP PGUID 12 1 0 0 0 f f f t t f i s 5 0 16 "1184 1184 1186 16 16" _null_ _null_ _null_ _null_ _null_ in_range_timestamptz_interval_desc _null_ _null_ _null_ ));
+DESCR("in range for timestamptz column, interval offset, descending");
+DATA(insert OID = 6144 (  in_range_interval_interval_asc PGNSP PGUID 12 1 0 0 0 f f f t t f i s 5 0 16 "1186 1186 1186 16 16" _null_ _null_ _null_ _null_ _null_ in_range_interval_interval_asc _null_ _null_ _null_ ));
+DESCR("in range for interval column, interval offset, ascending");
+DATA(insert OID = 6145 (  in_range_interval_interval_desc PGNSP PGUID 12 1 0 0 0 f f f t t f i s 5 0 16 "1186 1186 1186 16 16" _null_ _null_ _null_ _null_ _null_ in_range_interval_interval_desc _null_ _null_ _null_ ));
+DESCR("in range for interval column, interval offset, descending");
+DATA(insert OID = 6146 (  in_range_timetz_interval_asc PGNSP PGUID 12 1 0 0 0 f f f t t f i s 5 0 16 "1266 1266 1186 16 16" _null_ _null_ _null_ _null_ _null_ in_range_timetz_interval_asc _null_ _null_ _null_ ));
+DESCR("in range for timetz column, interval offset, ascending");
+DATA(insert OID = 6147 (  in_range_timetz_interval_desc PGNSP PGUID 12 1 0 0 0 f f f t t f i s 5 0 16 "1266 1266 1186 16 16" _null_ _null_ _null_ _null_ _null_ in_range_timetz_interval_desc _null_ _null_ _null_ ));
+DESCR("in range for timetz column, interval offset, descending");
+DATA(insert OID = 6148 (  in_range_date_interval_asc PGNSP PGUID 12 1 0 0 0 f f f t t f i s 5 0 16 "1082 1082 1186 16 16" _null_ _null_ _null_ _null_ _null_ in_range_date_interval_asc _null_ _null_ _null_ ));
+DESCR("in range for date column, interval offset, ascending");
+DATA(insert OID = 6149 (  in_range_date_interval_desc PGNSP PGUID 12 1 0 0 0 f f f t t f i s 5 0 16 "1082 1082 1186 16 16" _null_ _null_ _null_ _null_ _null_ in_range_date_interval_desc _null_ _null_ _null_ ));
+DESCR("in range for date column, interval offset, descending");
+DATA(insert OID = 6150 (  in_range_time_interval_asc PGNSP PGUID 12 1 0 0 0 f f f t t f i s 5 0 16 "1083 1083 1186 16 16" _null_ _null_ _null_ _null_ _null_ in_range_time_interval_asc _null_ _null_ _null_ ));
+DESCR("in range for time column, interval offset, ascending");
+DATA(insert OID = 6151 (  in_range_time_interval_desc PGNSP PGUID 12 1 0 0 0 f f f t t f i s 5 0 16 "1083 1083 1186 16 16" _null_ _null_ _null_ _null_ _null_ in_range_time_interval_desc _null_ _null_ _null_ ));
+DESCR("in range for time column, interval offset, descending");
+
 /* To ASCII conversion */
 DATA(insert OID = 1845 ( to_ascii	PGNSP PGUID 12 1 0 0 0 f f f f t f i s 1 0 25 "25" _null_ _null_ _null_ _null_ _null_ to_ascii_default _null_ _null_ _null_ ));
 DESCR("encode text from DB encoding to ASCII text");
diff --git a/src/include/nodes/execnodes.h b/src/include/nodes/execnodes.h
index 1bf67455e0..1f96de0542 100644
--- a/src/include/nodes/execnodes.h
+++ b/src/include/nodes/execnodes.h
@@ -1893,6 +1893,8 @@ typedef struct WindowAggState
 	int64		aggregatedbase; /* start row for current aggregates */
 	int64		aggregatedupto; /* rows before this one are aggregated */
 
+	PGFunction	startRangeFunc;	/* Start comparator func, used for RANGE with values */
+	PGFunction	endRangeFunc;	/* End comparator func, used for RANGE with values */
 	int			frameOptions;	/* frame_clause options, see WindowDef */
 	ExprState  *startOffset;	/* expression for starting bound offset */
 	ExprState  *endOffset;		/* expression for ending bound offset */
@@ -1922,6 +1924,16 @@ typedef struct WindowAggState
 	TupleTableSlot *agg_row_slot;
 	TupleTableSlot *temp_slot_1;
 	TupleTableSlot *temp_slot_2;
+
+	/* used for RANGE BETWEEN and GROUPS BETWEEN with values */
+	int64		winGroupsCount;	/* number of window groups */
+	int64		*winGroupLen;	/* length of each window group */
+	int64		*currWinGroup;	/* current window group */
+	int64		prevRowTotal;	/* previous row total */
+	int64		*frameheadWinGroup;	/* window group for the frame head */
+	int64		*frametailWinGroup;	/* window group for the frame tail */
+	int64		frameheadGroupsCount; /* count of frame head groups */
+	int64		frametailGroupsCount; /* count of frame tail groups */
 } WindowAggState;
 
 /* ----------------
diff --git a/src/include/nodes/parsenodes.h b/src/include/nodes/parsenodes.h
index 76a73b2a37..ed743e01cc 100644
--- a/src/include/nodes/parsenodes.h
+++ b/src/include/nodes/parsenodes.h
@@ -499,22 +499,28 @@ typedef struct WindowDef
  * which were defaulted; the correct behavioral bits must be set either way.
  * The START_foo and END_foo options must come in pairs of adjacent bits for
  * the convenience of gram.y, even though some of them are useless/invalid.
- * We will need more bits (and fields) to cover the full SQL:2008 option set.
  */
 #define FRAMEOPTION_NONDEFAULT					0x00001 /* any specified? */
 #define FRAMEOPTION_RANGE						0x00002 /* RANGE behavior */
 #define FRAMEOPTION_ROWS						0x00004 /* ROWS behavior */
-#define FRAMEOPTION_BETWEEN						0x00008 /* BETWEEN given? */
-#define FRAMEOPTION_START_UNBOUNDED_PRECEDING	0x00010 /* start is U. P. */
-#define FRAMEOPTION_END_UNBOUNDED_PRECEDING		0x00020 /* (disallowed) */
-#define FRAMEOPTION_START_UNBOUNDED_FOLLOWING	0x00040 /* (disallowed) */
-#define FRAMEOPTION_END_UNBOUNDED_FOLLOWING		0x00080 /* end is U. F. */
-#define FRAMEOPTION_START_CURRENT_ROW			0x00100 /* start is C. R. */
-#define FRAMEOPTION_END_CURRENT_ROW				0x00200 /* end is C. R. */
-#define FRAMEOPTION_START_VALUE_PRECEDING		0x00400 /* start is V. P. */
-#define FRAMEOPTION_END_VALUE_PRECEDING			0x00800 /* end is V. P. */
-#define FRAMEOPTION_START_VALUE_FOLLOWING		0x01000 /* start is V. F. */
-#define FRAMEOPTION_END_VALUE_FOLLOWING			0x02000 /* end is V. F. */
+#define FRAMEOPTION_GROUPS						0x00008 /* GROUPS behavior */
+#define FRAMEOPTION_BETWEEN						0x00010 /* BETWEEN given? */
+#define FRAMEOPTION_START_UNBOUNDED_PRECEDING	0x00020 /* start is U. P. */
+#define FRAMEOPTION_END_UNBOUNDED_PRECEDING		0x00040 /* (disallowed) */
+#define FRAMEOPTION_START_UNBOUNDED_FOLLOWING	0x00080 /* (disallowed) */
+#define FRAMEOPTION_END_UNBOUNDED_FOLLOWING		0x00100 /* end is U. F. */
+#define FRAMEOPTION_START_CURRENT_ROW			0x00200 /* start is C. R. */
+#define FRAMEOPTION_END_CURRENT_ROW				0x00400 /* end is C. R. */
+#define FRAMEOPTION_START_VALUE_PRECEDING		0x00800 /* start is V. P. */
+#define FRAMEOPTION_END_VALUE_PRECEDING			0x01000 /* end is V. P. */
+#define FRAMEOPTION_START_VALUE_FOLLOWING		0x02000 /* start is V. F. */
+#define FRAMEOPTION_END_VALUE_FOLLOWING			0x04000 /* end is V. F. */
+#define FRAMEOPTION_RANGE_BETWEEN				0x08000 /* RANGE BETWEEN with values */
+#define FRAMEOPTION_GROUPS_BETWEEN				0x010000 /* GROUPS BETWEEN with values */
+#define FRAMEOPTION_EXCLUDE_CURRENT				0x020000 /* exclude current row */
+#define FRAMEOPTION_EXCLUDE_TIES				0x040000 /* exclude ties */
+#define FRAMEOPTION_EXCLUDE_NO_OTHERS			0x080000 /* exclude no others */
+#define FRAMEOPTION_EXCLUDE_GROUP				0x100000 /* exclude group */
 
 #define FRAMEOPTION_START_VALUE \
 	(FRAMEOPTION_START_VALUE_PRECEDING | FRAMEOPTION_START_VALUE_FOLLOWING)
@@ -525,6 +531,10 @@ typedef struct WindowDef
 	(FRAMEOPTION_RANGE | FRAMEOPTION_START_UNBOUNDED_PRECEDING | \
 	 FRAMEOPTION_END_CURRENT_ROW)
 
+#define FRAMEOPTION_EXCLUSION \
+	(FRAMEOPTION_EXCLUDE_CURRENT | FRAMEOPTION_EXCLUDE_TIES | \
+	 FRAMEOPTION_EXCLUDE_GROUP)
+
 /*
  * RangeSubselect - subquery appearing in a FROM clause
  */
@@ -1275,8 +1285,9 @@ typedef struct GroupingSet
  * if the clause originally came from WINDOW, and is NULL if it originally
  * was an OVER clause (but note that we collapse out duplicate OVERs).
  * partitionClause and orderClause are lists of SortGroupClause structs.
- * winref is an ID number referenced by WindowFunc nodes; it must be unique
- * among the members of a Query's windowClause list.
+ * startRangeFunc and/or endRangeFunc are set if the clause is a RANGE BETWEEN
+ * with values. winref is an ID number referenced by WindowFunc nodes;it must
+ * be unique among the members of a Query's windowClause list.
  * When refname isn't null, the partitionClause is always copied from there;
  * the orderClause might or might not be copied (see copiedOrder); the framing
  * options are never copied, per spec.
@@ -1288,6 +1299,8 @@ typedef struct WindowClause
 	char	   *refname;		/* referenced window name, if any */
 	List	   *partitionClause;	/* PARTITION BY list */
 	List	   *orderClause;	/* ORDER BY list */
+	Oid			startRangeOid;	/* Start comparator Oid, used for RANGE with values */
+	Oid			endRangeOid;	/* End comparator Oid, used for RANGE with values */
 	int			frameOptions;	/* frame_clause options, see WindowDef */
 	Node	   *startOffset;	/* expression for starting bound, if any */
 	Node	   *endOffset;		/* expression for ending bound, if any */
diff --git a/src/include/nodes/plannodes.h b/src/include/nodes/plannodes.h
index baf3c07417..ce2cbf1ef7 100644
--- a/src/include/nodes/plannodes.h
+++ b/src/include/nodes/plannodes.h
@@ -808,6 +808,8 @@ typedef struct WindowAgg
 	int			ordNumCols;		/* number of columns in ordering clause */
 	AttrNumber *ordColIdx;		/* their indexes in the target list */
 	Oid		   *ordOperators;	/* equality operators for ordering columns */
+	Oid			startRangeOid;	/* Start comparator Oid, used for RANGE with values */
+	Oid			endRangeOid;	/* End comparator Oid, used for RANGE with values */
 	int			frameOptions;	/* frame_clause options, see WindowDef */
 	Node	   *startOffset;	/* expression for starting bound, if any */
 	Node	   *endOffset;		/* expression for ending bound, if any */
diff --git a/src/include/parser/kwlist.h b/src/include/parser/kwlist.h
index 26af944e03..cf32197bc3 100644
--- a/src/include/parser/kwlist.h
+++ b/src/include/parser/kwlist.h
@@ -182,6 +182,7 @@ PG_KEYWORD("granted", GRANTED, UNRESERVED_KEYWORD)
 PG_KEYWORD("greatest", GREATEST, COL_NAME_KEYWORD)
 PG_KEYWORD("group", GROUP_P, RESERVED_KEYWORD)
 PG_KEYWORD("grouping", GROUPING, COL_NAME_KEYWORD)
+PG_KEYWORD("groups", GROUPS, UNRESERVED_KEYWORD)
 PG_KEYWORD("handler", HANDLER, UNRESERVED_KEYWORD)
 PG_KEYWORD("having", HAVING, RESERVED_KEYWORD)
 PG_KEYWORD("header", HEADER_P, UNRESERVED_KEYWORD)
@@ -283,6 +284,7 @@ PG_KEYWORD("options", OPTIONS, UNRESERVED_KEYWORD)
 PG_KEYWORD("or", OR, RESERVED_KEYWORD)
 PG_KEYWORD("order", ORDER, RESERVED_KEYWORD)
 PG_KEYWORD("ordinality", ORDINALITY, UNRESERVED_KEYWORD)
+PG_KEYWORD("others", OTHERS, UNRESERVED_KEYWORD)
 PG_KEYWORD("out", OUT_P, COL_NAME_KEYWORD)
 PG_KEYWORD("outer", OUTER_P, TYPE_FUNC_NAME_KEYWORD)
 PG_KEYWORD("over", OVER, UNRESERVED_KEYWORD)
@@ -397,6 +399,7 @@ PG_KEYWORD("template", TEMPLATE, UNRESERVED_KEYWORD)
 PG_KEYWORD("temporary", TEMPORARY, UNRESERVED_KEYWORD)
 PG_KEYWORD("text", TEXT_P, UNRESERVED_KEYWORD)
 PG_KEYWORD("then", THEN, RESERVED_KEYWORD)
+PG_KEYWORD("ties", TIES, UNRESERVED_KEYWORD)
 PG_KEYWORD("time", TIME, COL_NAME_KEYWORD)
 PG_KEYWORD("timestamp", TIMESTAMP, COL_NAME_KEYWORD)
 PG_KEYWORD("to", TO, RESERVED_KEYWORD)
diff --git a/src/include/parser/parse_node.h b/src/include/parser/parse_node.h
index 4e96fa7907..1abfe2400f 100644
--- a/src/include/parser/parse_node.h
+++ b/src/include/parser/parse_node.h
@@ -45,6 +45,7 @@ typedef enum ParseExprKind
 	EXPR_KIND_WINDOW_ORDER,		/* window definition ORDER BY */
 	EXPR_KIND_WINDOW_FRAME_RANGE,	/* window frame clause with RANGE */
 	EXPR_KIND_WINDOW_FRAME_ROWS,	/* window frame clause with ROWS */
+	EXPR_KIND_WINDOW_FRAME_GROUPS,	/* window frame clause with GROUPS */
 	EXPR_KIND_SELECT_TARGET,	/* SELECT target list item */
 	EXPR_KIND_INSERT_TARGET,	/* INSERT target list item */
 	EXPR_KIND_UPDATE_SOURCE,	/* UPDATE assignment source item */
